#include "plane.h"
#include <memory>
#include <limits>
#include <pybind11/pybind11.h>
#include <pybind11/stl_bind.h>
#include <pybind11/numpy.h>

namespace py = pybind11;
using namespace pybind11::literals;

namespace batoid {
    void pyExportPlane(py::module& m) {
        py::class_<Plane, std::shared_ptr<Plane>, Surface>(m, "CPPPlane")
            .def(py::init<bool>(), "init", "allowReverse"_a=false)
            .def_property_readonly("allowReverse", &Plane::getAllowReverse);
    }
}
